

(function( $ ) {
	'use strict';

  var buildUrl = function(path) {
    return window.servicetradePortalConfig ? window.servicetradePortalConfig.apiRoot + path : path;
  };
  
  var dataTableRendererStatus = function (data, type, row) {
    if (data === 'active') {
        return 'Active';
    } else {
        return 'Inactive';
    }
  };

  var dataTableRendererCanRequestService = function (data, type, row) {
    if (type === 'display') {
      if(data.canSetRequestService) {
        return '<input type="checkbox" class="editor-can-request-service editor-checkbox" data-user-id="' + data.id + '" data-action="can-request-services">';
      } else {
        return '<input type="checkbox" style="cursor:default" disabled data-user-id="' + data.id + '">';
      }
    }
    return data;
  };
  
  var dataTableRendererViewQuotes = function (data, type, row) {
    if (type === 'display') {
        return '<input type="checkbox" class="editor-can-view-quotes editor-checkbox" data-user-id="' + data.id + '" data-action="can-view-quotes">';
    }
    return data;
  };

  var dataTableRendererViewDeficiencies = function (data, type, row) {
    if (type === 'display') {
        return '<input type="checkbox" class="editor-can-view-deficiencies editor-checkbox" data-user-id="' + data.id + '" data-action="can-view-deficiencies">';
    }
    return data;
  };

  var dataTableRendererViewPrices = function (data, type, row) {
    if (type === 'display') {
        return '<input type="checkbox" class="editor-can-view-prices editor-checkbox" data-user-id="' + data.id + '" data-action="can-view-prices">';
    }
    return data;
  };

  var dataTableRendererActions =  function (data, type, row) {
    if (data.status === 'active') {
      return '<span class="servicetrade-portal-spinner">Updating</span>' +
             '<a class="editor-action servicetrade-portal-action" data-user-id="' + data.id + '" data-action="deactivate-user" style="cursor: pointer;">Deactivate</a> ';
    } else {
      return '<span class="servicetrade-portal-spinner">Updating</span>' +
             '<a class="editor-action servicetrade-portal-action" data-user-id="' + data.id + '" data-action="activate-user" style="cursor: pointer;">Activate</a> ' +
             '<a class="editor-action servicetrade-portal-action servicetrade-portal-action-delete" data-user-id="' + data.id + '" data-action="delete-user" style="cursor: pointer;">Delete</a> ';
    }
  };


  var dataTableRendererActionsNewUsers =  function (data, type, row) {
    return '<span class="servicetrade-portal-spinner">Updating</span>' +
           '<a class="editor-action servicetrade-portal-action" data-user-id="' + data.id + '" data-action="accept-new-user" style="cursor: pointer;">Accept</a> ' +
           '<a class="editor-action servicetrade-portal-action" data-user-id="' + data.id + '" data-action="reject-new-user" style="cursor: pointer;">Reject</a> '

  };

  var dataTableNewUsersRowCallback = function(row, data) {
    $('input.editor-can-request-service', row).prop('checked', data.canRequestService == 1);
    $('input.editor-can-view-quotes', row).prop('checked', data.canViewQuotes == 1);
    $('input.editor-can-view-deficiencies', row).prop('checked', data.canViewDeficiencies == 1);
    $('input.editor-can-view-prices', row).prop('checked', data.canViewPrices == 1);
  };

  var dataTableUsersRowCallback = function(row, data) {
    $('input.editor-can-request-service', row).prop('checked', data.canRequestService == 1);
    $('input.editor-can-view-quotes', row).prop('checked', data.canViewQuotes == 1);
    $('input.editor-can-view-deficiencies', row).prop('checked', data.canViewDeficiencies == 1);
    $('input.editor-can-view-prices', row).prop('checked', data.canViewPrices == 1);
  };

  var postAction = function(actionName,userId, value,dataTable,tableRow,$tr) {
    // console.log('---- ' + actionName );
    // console.log('UserId: ' + userId + ' value ' + value);

    var urlSegment = '';
    var data = {};
    var method = 'POST';
    var showWorking = false;

    switch(actionName) {
      case 'can-request-services':
        urlSegment = '';
        data = {canRequestService: value};
        method = 'PUT';
        break;
      case 'can-view-quotes':
        urlSegment = '';
        data = {canViewQuotes: value};
        method = 'PUT';
        break;
      case 'can-view-deficiencies':
        urlSegment = '';
        data = {canViewDeficiencies: value};
        method = 'PUT';
        break;
      case 'can-view-prices':
        urlSegment = '';
        data = {canViewPrices: value};
        method = 'PUT';
        break;
      case 'activate-user':
        urlSegment = '/activate';
        showWorking = true;
        break;
      case 'deactivate-user':
        urlSegment = '/deactivate';
        data = {};
        showWorking = true;
        break;
      case 'delete-user':
        urlSegment = '/delete';
        showWorking = true;
        break;
      case 'accept-new-user':
        urlSegment = '/access-requested/accept';
        // TODO -> Get all values from row
       
        data = {
          canRequestService: $('input.editor-can-request-service', $tr).is(':checked'),
          canViewQuotes: $('input.editor-can-view-quotes', $tr).is(':checked'),
          canViewDeficiencies: $('input.editor-can-view-deficiencies', $tr).is(':checked'),
          canViewPrices: $('input.editor-can-view-prices', $tr).is(':checked')
        };

        showWorking = true;
        break;
      case 'reject-new-user':
        urlSegment = '/access-requested/reject';
        showWorking = true;
        break;
    }

    if(showWorking) {
      $tr.addClass('servicetrade-portal-working');
    }

    $.ajax({
      type: method,
      data: data,
      url: buildUrl('users/' + userId + urlSegment),
      dataType: 'json',
      encode: true,
      beforeSend: ( xhr ) => {
        if (window.servicetradePortalConfig &&
            window.servicetradePortalConfig.nonce) {
          xhr.setRequestHeader( 'X-WP-Nonce', window.servicetradePortalConfig.nonce );
        }
      }
  })
  // .always(function() {
  //   $tr.removeClass('servicetrade-portal-working');
  // })
  .done(function(data) {
    switch(actionName) {
      case 'accept-new-user':
      case 'reject-new-user':
        newUsersDataTable().ajax.reload();
        usersDataTable().ajax.reload();
        break;
      case 'activate-user':
      case 'deactivate-user':
        usersDataTable().ajax.reload();
        break;
      case 'delete-user':
        usersDataTable().ajax.reload();
        break;
    }
    if(showWorking) {      
      $tr.removeClass('servicetrade-portal-working');
      $tr.addClass('servicetrade-portal-success'); // removes flicker
    }
  })
  .fail(function() { 
    $tr.removeClass('servicetrade-portal-working');
  });
  };

  /**
   * Returns the previously initialized data table for the new users section.
   */
  var newUsersDataTable = function() {
    return $('.servicetrade-portal-view-model-new-users-data').DataTable();
  };

  /**
   * Returns the previously initialized data table for the users section.
   */
  var usersDataTable = function() {
    return $('.servicetrade-view-model-users-data').DataTable();
  };

  $( document ).ready(function() {
    $.fn.dataTable.ext.errMode = 'none';
    $('.servicetrade-portal-view-model-new-users-data').DataTable({
      ajax: {
        url: buildUrl('users/access-requested'),
        dataSrc: 'users',
        cache: false,
        beforeSend: ( xhr ) => {
          if (window.servicetradePortalConfig &&
              window.servicetradePortalConfig.nonce) {
            xhr.setRequestHeader( 'X-WP-Nonce', window.servicetradePortalConfig.nonce );
          }
        }
      },
      "language": {
        "emptyTable": "No new user requests."
      },
      rowCallback: dataTableNewUsersRowCallback,
      columns: [
        {
          "data": "displayName",
          "title": "Name"},
        {
          "data": "email",
          "title": "Email"},
          {
            title: 'Request Service',
            data: {"id": "id", "canRequestService":"canRequestService","canSetRequestService":"canSetRequestService"},
            render: dataTableRendererCanRequestService,
            className: "dt-body-center"
          },
          {
            title: 'View Quotes',
            data: {"id": "id", "canViewQuotes":"canViewQuotes"},
            render: dataTableRendererViewQuotes,
            className: "dt-body-center"
          },
          {
            title: 'View Deficiencies',
            data: {"id": "id", "canViewDeficiencies":"canViewDeficiencies"},
            render: dataTableRendererViewDeficiencies,
            className: "dt-body-center"
          },
          {
            data: {"id": "id", "canViewPrices":"canViewPrices"},
            title: 'View Prices',
            render: dataTableRendererViewPrices,
            className: "dt-body-center"
          },
  
          {
            data: {"id": "id", "status": "status"},
            title: 'Actions',
            render: dataTableRendererActionsNewUsers,
            className: "dt-body-center"
          }        
        
        ]});


    var $dataTableUsers = $('.servicetrade-view-model-users-data').DataTable({
      ajax: {
        url: buildUrl('users'),
        dataSrc: 'users',
        cache: false,
        beforeSend: ( xhr ) => {
          if (window.servicetradePortalConfig &&
              window.servicetradePortalConfig.nonce) {
            xhr.setRequestHeader( 'X-WP-Nonce', window.servicetradePortalConfig.nonce );
          }
        }
      },
      "language": {
        "emptyTable": "No users available."
      },
      rowCallback: dataTableUsersRowCallback,
      columns: [
        {
          data: 'username',
          title: 'Name'},
        {
          data: 'email',
          title: 'Email'},
        {
            data: 'status',
            title: 'Status',
            render: dataTableRendererStatus
        },
        {
          title: 'Request Service',
          data: {"id": "id", "canRequestService":"canRequestService","canSetRequestService":"canSetRequestService"},
          render: dataTableRendererCanRequestService,
          className: "dt-body-center"
        },
        {
          title: 'View Quotes',
          data: {"id": "id", "canViewQuotes":"canViewQuotes"},
          render: dataTableRendererViewQuotes,
          className: "dt-body-center"
        },
        {
          title: 'View Deficiencies',
          data: {"id": "id", "canViewDeficiencies":"canViewDeficiencies"},
          render: dataTableRendererViewDeficiencies,
          className: "dt-body-center"
        },
        {
          data: {"id": "id", "canViewPrices":"canViewPrices"},
          title: 'View Prices',
          render: dataTableRendererViewPrices,
          className: "dt-body-center"
        },

        {
          data: {"id": "id", "status": "status"},
          title: 'Actions',
          render: dataTableRendererActions,
          className: "dt-body-center"
        }
      ]});

    // Checkbox changes
    $('.servicetrade-view-model-users-data').on( 'change', 'input.editor-checkbox', function(e) {
      e.preventDefault();
      var userId = $(this).data('user-id');
      var action = $(this).data('action');
      
      var dataTable = $(this).closest('table').DataTable();
      var $tr = $(this).closest('tr');
      var tableRow = dataTable.row($tr);

      postAction(action,userId,$(this).prop( 'checked' ),dataTable,tableRow,$tr)
    });

    // Action clicks
    $('.servicetrade-portal-view-model-new-users-data,.servicetrade-view-model-users-data').on( 'click', 'a.editor-action', function(e) {
      e.preventDefault();
      var userId = $(this).data('user-id');
      var action = $(this).data('action');

      var dataTable = $(this).closest('table').DataTable();
      var $tr = $(this).closest('tr');
      var tableRow = dataTable.row($tr);

      postAction(action,userId,true,dataTable,tableRow,$tr)
    });

  });
})( jQuery );
