<?php

require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'includes/models/class-api-credentials.php';
require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'includes/models/class-servicetrade-options.php';
require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'vendor/servicetrade/servicetrade-php/Servicetrade.php';
require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'includes/class-servicetrade-authenticated-api.php';

/**
 * Base class for an action. Provides access to the API
 *
 *
 * @link       http://www.servicetrade.com
 * @since      2.0.0
 * @package    Servicetrade_Service_Portal
 * @subpackage Servicetrade_Service_Portal/includes
 * @author     ServiceTrade <support@servicetrade.com>
 */
class Servicetrade_Action {

  /**
	 * Get the ServiceTrade API connection object, creating a connection
	 * if it doesn't exist already
	 *
	 * @since     1.0.0
	 * @return    object    ServiceTrade API connection object
	 */
	protected function st_api() {
		return Servicetrade_Authenticated_API::api();
	}

	protected function api_get($query) {
		return $this->st_api()->get($query);
	}

}
