<?php

require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'includes/class-servicetrade-action.php';
require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'includes/class-servicetrade-user-meta.php';
require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'public/rest/class-public-rest-action.php';

/**
 * Returns the config for the logged in user.
 *
 * An action class.
 *
 * @link       http://www.servicetrade.com
 * @since      2.0.0
 * @package    Servicetrade_Service_Portal
 * @subpackage Servicetrade_Service_Portal/public/rest/actions
 * @author     ServiceTrade <support@servicetrade.com>
 */
class Servicetrade_Service_Portal_Public_Actions_Rest_Config_Get_Action extends Servicetrade_Service_Portal_Public_Rest_Action {

  function run() {

    $currentUserId = get_current_user_id();

    if($currentUserId === 0 ) {
      return $this->create_rest_success(array('loggedIn' => false));
    }

    $result = array( 'loggedIn' => true,
                     'status' => Servicetrade_User_Meta::get_status($currentUserId),
                     'canRequestService' => Servicetrade_Models_ServiceTrade_Options::get_request_service() && Servicetrade_User_Meta::get_can_request_service($currentUserId),
                     'canViewQuotes' => Servicetrade_User_Meta::get_can_view_quotes($currentUserId),
                     'canViewDeficiencies' => Servicetrade_User_Meta::get_can_view_deficiencies($currentUserId),
                     'canViewPrices' => Servicetrade_User_Meta::get_can_view_prices($currentUserId) );
    return $this->create_rest_success($result);
  }
}
