<?php

require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'includes/class-servicetrade-action.php';
require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'public/rest/class-public-rest-action.php';

/**
 * Returns a single location.
 *
 * An action class.
 *
 * @link       http://www.servicetrade.com
 * @since      2.0.0
 * @package    Servicetrade_Service_Portal
 * @subpackage Servicetrade_Service_Portal/public/rest/actions
 * @author     ServiceTrade <support@servicetrade.com>
 */
class Servicetrade_Service_Portal_Public_Actions_Rest_Location_Get_Action extends Servicetrade_Service_Portal_Public_Rest_Action {
  private $id;

  function __construct($id) {
    assert($id !== null, "An id is required.");
    $this->id = $id;
  }

  function run() {
    $user = $this->get_authenticated_user();
    if(null === $user) {
			return $this->create_rest_error_not_authorized();
    }

    $apiResult = $this->api_get($this->build_location_query());
    return $this->create_rest_success($apiResult);
  }

  protected function build_location_query() {
		$query = array();
    return '/location/' . $this->id . '?' . http_build_query($query);
  }
}
