<?php

require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'includes/class-servicetrade-action.php';
require_once SERVICETRADE_PORTAL_PLUGIN_ROOT_DIR . 'public/rest/class-public-rest-action.php';

/**
 * Creates a user account and requests access.
 *
 * @link       http://www.servicetrade.com
 * @since      2.0.0
 * @package    Servicetrade_Service_Portal
 * @subpackage Servicetrade_Service_Portal/public/rest/actions
 * @author     ServiceTrade <support@servicetrade.com>
 */
class Servicetrade_Service_Portal_Public_Actions_Rest_Validate_Email_Access_Post_Action extends Servicetrade_Service_Portal_Public_Rest_Action {

  private $code;

  public function __construct( $code ) {
    $this->code = $code;
  }

  //@TODO from here
  function run() {
    // Validate basics

    if (!$this->code) {
      return new WP_Error( 'servicetrade_validation_no_code', 'Code not provided', array( 'status' => 422 ) );
	 }

	 $data = unserialize(base64_decode($this->code));
    if (!$data) {
      return new WP_Error( 'servicetrade_validation_no_data', 'Data not provided', array( 'status' => 422 ) );
	 }
	 $userId = $data['id'];
    if (!$userId) {
      return new WP_Error( 'servicetrade_validation_no_userid', 'User ID not provided', array( 'status' => 422 ) );
	 }
	 $activationCode = $data['code'];
    if (!$data) {
      return new WP_Error( 'servicetrade_validation_no_activation_code', 'Activation code not provided', array( 'status' => 422 ) );
	 }

	 $userCode = get_user_meta($userId, 'activation_code', true);
	 if ($userCode == $activationCode) {
		update_user_meta($userId, 'is_activated', 1);
		wc_add_notice( __( '<strong>Success:</strong> Your user has been activated! ', 'text-domain' )  );
	 } else {
		wc_add_notice( __( '<strong>Error:</strong> Your user could not be activated ', 'text-domain' )  );
	 }

	 //@TODO below this

    return new WP_REST_Response( array(), 200 );
  }
}
